# nlvmi

Native Lightweight Vm Management Interface

Nlvmi is a management interface for qemu/kvm hosts written in php (with bootstrap) and bash.<br/>
Nlvmi should be able to run on any common Linux distro without much hassle or obscure dependencies. <br/>
Nlvmi is written to be lightweight, functional and easy to understand and modify, while still looking at least acceptable on any device.<br/>
Nlvmi supports multiple users (admins and restricted) on the frontend and also uses these users to run the VMs. No PAM, just su.<br/>
Unix users have /bin/false as shell and the password is stored within the nlvmi database.<br/>

**Deps:** <br/>
bash <br/>
bridge-utils <br/>
nginx / apache / lighttpd <br/>
openssh <br/>
php <br/>
socat <br/>
sqlite3 / mariadb (only sqlite3 for now)<br/>
usermode-utilities <br/>

